config/routes.rb
require 'avalon/routing/can_constraint'

Rails.application.routes.draw do
  mount Samvera::Persona::Engine => '/'
  mount Blacklight::Engine => '/catalog'
  concern :searchable, Blacklight::Routes::Searchable.new
  concern :exportable, Blacklight::Routes::Exportable.new

  resource :catalog, only: [:index], as: 'catalog', path: '/catalog', controller: 'catalog' do
    concerns :searchable
  end

  # For some reason this needs to be after `resource :catalog` otherwise Blacklight will generate links to / instead of /catalog
  root to: "catalog#index"

  get '/mejs/:version', to: 'application#mejs'

  resources :solr_documents, only: [:show], path: '/catalog', controller: 'catalog' do
    concerns :exportable
  end

  resources :encode_records, only: [:show, :index] do
    collection do
      post :paged_index
      post :progress
    end
  end

  resources :bookmarks do
    concerns :exportable

    collection do
      delete 'clear'
      get 'delete'#, as: :delete_bookmarks
      post 'delete'
      get 'move'#, as: :move_bookmarks
      post 'move'
      get 'update_access_control'#, as: :update_access_control_bookmarks
      post 'update_access_control'
      post 'publish'#, as: :publish_bookmarks
      post 'unpublish'#, as: :unpublish_bookmarks
      get 'add_to_playlist'
      post 'add_to_playlist'
      get 'intercom_push'
      post 'intercom_push'
      get 'merge'
      post 'merge'
    end
  end

  devise_for :users, controllers: { omniauth_callbacks: 'users/omniauth_callbacks', sessions: 'users/sessions' }, format: false
  devise_scope :user do
    match '/users/auth/:provider', to: 'users/omniauth_callbacks#passthru', as: :user_omniauth_authorize, via: [:get, :post]
    Avalon::Authentication::Providers.collect { |provider| provider[:provider] }.uniq.each do |provider_name|
      match "/users/auth/#{provider_name}/callback", to: "users/omniauth_callbacks##{provider_name}", as: "user_omniauth_callback_#{provider_name}".to_sym, via: [:get, :post]
    end
  end

  mount BrowseEverything::Engine => '/browse'

  # Avalon routes
  match "/authorize", to: 'derivatives#authorize', via: [:get, :post]
  match "/authorize/:path", to: 'derivatives#authorize', via: [:get, :post]

  namespace :admin do
    resources :groups, except: [:show] do
      collection do
        put 'update_multiple'
      end
      member do
        put 'update_users'
      end
    end
    resources :collections do
      member do
        get 'edit'
        get 'remove'
        get 'items'
        get 'poster'
        post 'poster', action: :attach_poster, as: 'attach_poster'
        delete 'poster', action: :remove_poster, as: 'remove_poster'
      end
    end

    namespace :migration_report, controller: '/migration_status' do
      get '/', action: :index
      get ':class', action: :show, as: 'by_class'
      get ':id/detail', action: :detail, as: 'detail'
      get ':id/report', action: :report, as: 'report'
    end
  end

  resources :vocabulary, except: [:create, :destroy, :new, :edit]

  resources :collections, only: [:index, :show] do
    member do
      get :poster
    end
  end

  resources :media_objects, except: [:create, :update] do
    member do
      put :update, action: :update, defaults: { format: 'html' }, constraints: { format: 'html' }
      put :update, action: :json_update, constraints: { format: 'json' }
      patch :update, action: :update, defaults: { format: 'html' }, constraints: { format: 'html' }
      put :update_status
      get :progress, :action => :show_progress
      get 'content/:file', :action => :deliver_content, :as => :inspect
      get 'track/:part', :action => :show, :as => :indexed_section
      get 'section/:content', :action => :show, :as => :id_section
      get 'section/:content/stream', :action => :show_stream_details, :as => :section_stream
      get 'section/:content/embed', :to => redirect('/master_files/%{content}/embed')
      get 'tree', :action => :tree, :as => :tree
      get :confirm_remove
      get :add_to_playlist_form
      post :add_to_playlist
      patch :intercom_push
      get :manifest
      get :move_preview, defaults: { format: 'json' }, constraints: { format: 'json' }
    end
    collection do
      post :create, action: :create, constraints: { format: 'json' }
      post :set_session_quality
      get :confirm_remove
      put :update_status
      # 'delete' has special signifigance so use 'remove' for now
      delete :remove, :action => :destroy
      get :intercom_collections
    end

    # Supplemental Files
    resources :supplemental_files, except: [:new, :index, :edit]
  end

  resources :master_files, except: [:new, :index] do
    member do
      get  'thumbnail', :to => 'master_files#get_frame', :defaults => { :type => 'thumbnail' }
      get  'poster',    :to => 'master_files#get_frame', :defaults => { :type => 'poster' }

      post 'thumbnail', :to => 'master_files#set_frame', :defaults => { :type => 'thumbnail', :format => 'html' }
      post 'poster',    :to => 'master_files#set_frame', :defaults => { :type => 'poster', :format => 'html' }
      post 'still',     :to => 'master_files#set_frame', :defaults => { :format => 'html' }
      get :embed
      post 'attach_structure'
      post 'attach_captions'
      get :captions
      get :waveform
      match ':quality.m3u8', to: 'master_files#hls_manifest', via: [:get], as: :hls_manifest
      get 'structure', to: 'master_files#structure', constraints: { format: 'json' }
      post 'structure', to: 'master_files#set_structure', constraints: { format: 'json' }
      delete 'structure', to: 'master_files#delete_structure', constraints: { format: 'json' }
      post 'move'
    end

    # Supplemental Files
    resources :supplemental_files, except: [:new, :index, :edit]
  end

  match "iiif_auth_token/:id", to: 'master_files#iiif_auth_token', via: [:get], as: :iiif_auth_token

  resources :derivatives, only: [:create]
  match "/autocomplete", to: 'objects#autocomplete', via: [:get]
  match "/objects/:id", to: 'objects#show', via: [:get], :as => :objects
  match "/object/:id", to: 'objects#show', via: [:get]

  resources :playlists do
    resources :playlist_items, path: 'items', only: [:create, :update, :show] do
      get 'markers'
      get 'source_details'
      get 'related_items'
    end
    member do
      patch 'update_multiple'
      delete 'update_multiple'
      patch 'regenerate_access_token'
      get 'refresh_info'
    end
    collection do
      post 'duplicate'
      post 'paged_index'
      if Settings['variations'].present?
        post 'import_variations_playlist'
      end
    end
  end

  resources :avalon_marker, only: [:create, :show, :update, :destroy]

  resources :comments, only: [:index, :create]

  resources :playlist_items, only: [:update], :constraints => {:format => /(js|json)/}

  resources :timelines do
    member do
      patch 'regenerate_access_token'
      post 'manifest', to: 'timelines#manifest_update', constraints: { format: 'json' }
      get 'manifest', constraints: { format: 'json' }
    end
    collection do
      post 'duplicate'
      post 'paged_index'
      if Settings['variations'].present?
        post 'import_variations_timeline'
      end
    end
  end
  get '/timeliner', to: 'timelines#timeliner', as: :timeliner

  resources :dropbox, :only => [] do
    collection do
      delete :bulk_delete
    end
  end

  match "/oembed", to: 'master_files#oembed', via: [:get]

  constraints(Avalon::Routing::CanConstraint.new(:read, :about_page)) do
    mount AboutPage::Engine => '/about(.:format)', as: 'about_page'
  end
  get '/about(.:format)', to: redirect('/')
  get '/about/health.yaml', to: 'about_page/about#health', defaults: { :format => 'yaml' }
  get '/about/health(.:format)', to: redirect('/')

  constraints(Avalon::Routing::CanConstraint.new(:manage, :jobs)) do
    mount Sidekiq::Web, at: '/jobs', as: 'jobs'
  end
  get '/jobs(.:format)', to: redirect('/')
end

app/models/playlist.rb
# Copyright 2011-2020, The Trustees of Indiana University and Northwestern
#   University.  Licensed under the Apache License, Version 2.0 (the "License");
#   you may not use this file except in compliance with the License.
#
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software distributed
#   under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
#   CONDITIONS OF ANY KIND, either express or implied. See the License for the
#   specific language governing permissions and limitations under the License.
# ---  END LICENSE_HEADER BLOCK  ---

class Playlist < ActiveRecord::Base
  belongs_to :user
  scope :by_user, ->(user) { where(user_id: user.id) }
  scope :title_like, ->(title_filter) { where("title LIKE ?", "%#{title_filter}%")}
  scope :with_tag, ->(tag_filter) { where("tags LIKE ?", "%\n- #{tag_filter}\n%") }

  validates :user, presence: true
  validates :title, presence: true
  validates :comment, length: { maximum: 255 }
  validates :visibility, presence: true
  validates :visibility, inclusion: { in: proc { [PUBLIC, PRIVATE, PRIVATE_WITH_TOKEN] } }

  delegate :url_helpers, to: 'Rails.application.routes'

  after_initialize :default_values
  before_save :generate_access_token, if: Proc.new{ |p| p.visibility == Playlist::PRIVATE_WITH_TOKEN && access_token.blank? }

  has_many :items, -> { order('position ASC') }, class_name: 'PlaylistItem', dependent: :destroy
  has_many :clips, -> { order('playlist_items.position ASC') }, class_name: 'AvalonClip', through: :items
  accepts_nested_attributes_for :items, allow_destroy: true

  serialize :tags

  # visibility
  PUBLIC = 'public'
  PRIVATE = 'private'
  PRIVATE_WITH_TOKEN = 'private-with-token'

  # Default values to be applied after initialization
  def default_values
    self.visibility ||= Playlist::PRIVATE
    self.tags ||= [];
  end

  def generate_access_token
    # TODO Use ActiveRecord's secure_token when we move to Rails 5
    self.access_token = loop do
      random_token = SecureRandom.urlsafe_base64(nil, false)
      break random_token unless self.class.exists?(access_token: random_token)
    end
  end

  # Returns all other playlist items on the same playlist that share a master file
  # @param [PlaylistItem] current_item The playlist item you want to find matches for
  # @return [Array <PlaylistItem>] an array of all other playlist items that reference the same master file
  def related_items(current_item)
    uri = AvalonClip.where(id: current_item.clip_id)[0].source
    items = PlaylistItem.joins(:clip).where('annotations.source_uri' => uri).where(playlist: self)
    # remove the current item
    return_items = []
    items.each do |item|
      return_items << item unless item.clip_id == current_item.clip_id
    end
    return_items
  end

  # Returns all other clips on the same playlist that share a master file
  # @param [PlaylistItem] current_item The playlist item you want to find matches for
  # @return [Array <AvalonClip>] an array of all other clips items that reference the same master file
  def related_clips(current_item)
    clips = []
    related_items(current_item).each do |item|
      clips << AvalonClip.find(item.clip_id)
    end
    clips
  end

  # Returns a list of clips that are on the same playlist, share the same masterfile, and whose start time falls within the start and end time of the current playlist item
  # @param [PlaylistItem] current_item The playlist item to match against
  # @return [Array <AvalonClip>] all clips matching the constraints
  def related_clips_time_contrained(current_item)
    current_clip = AvalonClip.where(id: current_item.clip_id)[0]
    clips = []
    related_items(current_item).each do |item|
      clip = AvalonClip.where(id: item.clip_id)[0]
      clips << clip if clip.start_time <= current_clip.end_time && clip.start_time >= current_clip.start_time
    end
    clips
  end

  def valid_token?(token)
    access_token == token && visibility == Playlist::PRIVATE_WITH_TOKEN
  end

  class << self
    # Find the i18n default playlist name
    def default_folder_name
      I18n.translate(:'playlists.default_playlist_name')
    end
  end # class << self
end

app/helpers/playlists_helper.rb
# Copyright 2011-2020, The Trustees of Indiana University and Northwestern
#   University.  Licensed under the Apache License, Version 2.0 (the "License");
#   you may not use this file except in compliance with the License.
#
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software distributed
#   under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
#   CONDITIONS OF ANY KIND, either express or implied. See the License for the
#   specific language governing permissions and limitations under the License.
# ---  END LICENSE_HEADER BLOCK  ---

module PlaylistsHelper
  def human_friendly_visibility(visibility)
    content_tag(:span,
      safe_join([icon_only_visibility(visibility),t("playlist.#{visibility}Text")], ' '),
      class: "human_friendly_visibility_#{visibility}",
      title: visibility_description(visibility))
  end

  def icon_only_visibility(visibility)
    icon = case visibility
      when Playlist::PUBLIC
        "fa-globe"
      when Playlist::PRIVATE
        "fa-lock"
      else
        "fa-link"
    end
    content_tag(:span, '', class:"fa #{icon} fa-lg", title: visibility_description(visibility))
  end

  def visibility_description(visibility)
    t("playlist.#{visibility}AltText")
  end
end

app/views/playlists/_current_item.html.erb
<%#
Copyright 2011-2020, The Trustees of Indiana University and Northwestern
  University.  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.

You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software distributed
  under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
  CONDITIONS OF ANY KIND, either express or implied. See the License for the
  specific language governing permissions and limitations under the License.
---  END LICENSE_HEADER BLOCK  ---
%>
<section id="metadata">
<div id="metadata_header">
  <h3>
    <%= link_to media_object_path(@current_mediaobject) do %>
      <% unless @current_mediaobject.title.blank? %>
        <%= @current_mediaobject.title %>
      <% else %>
        <%= @current_mediaobject.id %>
      <% end %>
      <%= "/ #{@current_mediaobject.statement_of_responsibility}" if @current_mediaobject.statement_of_responsibility.present? %>
    <% end %>
  </h3>
</div>
    
<dl id="creation_metadata">
  <%= display_metadata('Date', combined_display_date(@current_mediaobject), 'Not provided') %>
  <%= display_metadata('Main contributor', @current_mediaobject.creator) %>
  <% unless @current_mediaobject.abstract.blank? %>
  <dt>Summary</dt>
  <dd>
    <pre><%= @current_mediaobject.abstract %></pre>
  </dd>
  <% end %>
  <%= display_metadata('Contributor', @current_mediaobject.contributor) %>
  <%= display_metadata('Publisher', @current_mediaobject.publisher) %>
  <%= display_metadata('Genre', @current_mediaobject.genre) %>
  <%= display_metadata('Subject', @current_mediaobject.subject) %>
  <%= display_metadata('Time period', @current_mediaobject.temporal_subject) %>
  <%= display_metadata('Location', @current_mediaobject.geographic_subject) %>
  <%= display_metadata('Collection', @current_mediaobject.collection.name) %>
  <%= display_metadata('Unit', @current_mediaobject.collection.unit) %>
  <%= display_metadata('Language', display_language(@current_mediaobject)) %>
  <%= display_rights_statement(@current_mediaobject) %>
  <%= display_metadata('Terms of Use', @current_mediaobject.terms_of_use) %>
  <%= display_metadata('Physical Description', @current_mediaobject.physical_description) %>
  <%= display_metadata('Related Item', display_related_item(@current_mediaobject)) %>
  <%= display_metadata('Notes', display_notes(@current_mediaobject)) %>
  <%= display_metadata('Other Identifier', display_other_identifiers(@current_mediaobject)) %>

</dl>
</section>

app/views/playlists/_lti_url.html.erb
<%#
Copyright 2011-2020, The Trustees of Indiana University and Northwestern
  University.  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.

You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software distributed
  under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
  CONDITIONS OF ANY KIND, either express or implied. See the License for the
  specific language governing permissions and limitations under the License.
---  END LICENSE_HEADER BLOCK  ---
%>
<% if section=='tab-content' %>

    <div class="tab-pane text-left" id="lti-tab">
      <% if @playlist.visibility == Playlist::PUBLIC %>
      <p class="muted">Copy the link below to share this playlist via LTI</p>
      <form role="form">
        <div class="form-group">
          <input type="text" class="col-md-5 form-control" id="ltilink-object" value="<%= lti_share_url_for(@playlist) %>" onClick="this.select();" readonly="readonly">
        </div>
      </form>
      <% elsif @playlist.visibility == Playlist::PRIVATE_WITH_TOKEN %>
      <p class="muted">Copy the link below to share this playlist via LTI.  It can only be seen and shared by people with this link.</p>
      <form role="form">
        <div class="form-group">
          <input type="text" class="col-md-5 form-control" id="ltilink-object" value="<%= lti_share_url_for(@playlist, token: @playlist.access_token) %>" onClick="this.select();" readonly="readonly">
        </div>
      </form>
      <% else %>
      <p class="muted">This playlist is private.  To enable sharing, change the visibility setting within the <%= link_to "Edit Playlist", edit_playlist_url(@playlist) %> page.</p>
      <% end %>
    </div>

<% elsif section=='share-tabs' %>

    <li><a href="#lti-tab" data-toggle="tab">LTI URL</a></li>

<% end %>

app/views/playlists/_mejs4_playlist_item.html.erb
<%#
Copyright 2011-2020, The Trustees of Indiana University and Northwestern
  University.  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.

You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software distributed
  under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
  CONDITIONS OF ANY KIND, either express or implied. See the License for the
  specific language governing permissions and limitations under the License.
---  END LICENSE_HEADER BLOCK  ---
%>
<% item = @playlist.items[mejs4_playlist_item_counter] %>
<% item_class = (item == @current_playlist_item)? 'now_playing' : 'queue' %>
<% clip = clip_map[item.clip_id] %>

<% if clip.master_file.present? && can?(:read, clip.master_file.media_object) %>
  <% master_file = clip.master_file %>
  <% item_type = (master_file.file_format=='Moving image')? 'fa-film' : 'fa-music' %>

  <li class="<%= item_class %>" data-is-video="<%= clip.master_file.is_video? %>" data-playlist-item-id="<%= item.id %>">
    <% if can?(:read, master_file.media_object) %>
      <% dataset = { 'playlist-id' => item.playlist_id,
                     'playlist-item-id' => item.id,
                     'clip-start-time' => clip.start_time,
                     'clip-end-time' => clip.end_time,
                     'clip-source' => clip.source,
                     'media-object-id' => master_file.media_object_id,
                     'master-file-id' => master_file.id,
                     'can-edit-playlist-item' => (can? :edit, item),
                     'clip-comment' => clip.content } %>
      <%= link_to playlist_path(@playlist, position: clip.playlist_position(@playlist), token: @playlist_token), data: dataset do %>
        <%= clip.title %>
      <% end %>
    <% end %>
    <span class="pull-right"> <span class="fa <%= item_type %>"></span> <%= clip.duration %></span>
  </li>
<% else %>
  <% denied_class = item_class %>
  <% denied_class = 'denied_item' unless denied_class == 'now_playing'%>
  <li class= "<%= denied_class %> playlist_item_denied">
    <% if item_class == 'now_playing' %>
      <i class="fa fa-arrow-circle-right"></i>
    <% end %>
    <% if clip.master_file.nil? %>
      <i class="fa fa-times-circle"></i>
      <span title="The source for this playlist item has been deleted.">[Deleted Item]</span>
    <% else %>
      <i class="fa fa-lock"></i>
      <span title="You do not playback permission for the source item, <%=clip.master_file.media_object_id%>, this playlist item references.">[Inaccessible Item] <%=clip.master_file.media_object_id%></span>
    <% end %>
    <span class="pull-right"><%= clip.duration %></span>
  </li>
<% end %>

app/views/playlists/_playlist_item.html.erb
<%#
Copyright 2011-2020, The Trustees of Indiana University and Northwestern
  University.  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.

You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software distributed
  under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
  CONDITIONS OF ANY KIND, either express or implied. See the License for the
  specific language governing permissions and limitations under the License.
---  END LICENSE_HEADER BLOCK  ---
%>
<% item = @playlist.items[playlist_item_counter] %>
<% item_class = (item == @current_playlist_item)? 'now_playing' : 'queue' %>
<% clip = clip_map[item.clip_id] %>
<% if clip.master_file.present? && can?(:read, clip.master_file.media_object) %>
  <% item_type = (clip.master_file.file_format=='Moving image')? 'fa-film' : 'fa-music' %>
  <li class="<%= item_class %>" is_video="<%= clip.master_file.is_video? %>" data-playlist-item-id="<%= item.id %>">
    <% if item_class == 'now_playing' %>
      <i class="fa fa-arrow-circle-right"></i>
    <% end %>
    <% masterfile = clip.master_file %>
    <% if @current_masterfile.is_video? == masterfile.is_video? && can?(:read, @current_playlist_item.clip.master_file.media_object) %>
      <%= link_to refresh_info_playlist_path(@playlist, position: item.position, token: @playlist_token, autostart: true, mejs4: is_mejs_4? ? true : false), remote: true do%>
        <%= clip.title %>
      <% end %>
    <% else %>
      <%= link_to playlist_path(@playlist, position: item.position, token: @playlist_token, autostart: true, mejs4: is_mejs_4? ? true : false) do %>
        <%= clip.title %>
      <% end %>
    <% end %>
  <span class="pull-right"> <span class="fa <%= item_type %>"></span> <%= clip.duration %></span>
  </li>
<% else %>
  <% denied_class = item_class %>
  <% denied_class = 'denied_item' unless denied_class == 'now_playing'%>
  <li class= "<%= denied_class %> playlist_item_denied">
    <% if item_class == 'now_playing' %>
      <i class="fa fa-arrow-circle-right"></i>
    <% end %>
    <% if clip.master_file.nil? %>
      <i class="fa fa-times-circle"></i>
      <span title="The source for this playlist item has been deleted.">[Deleted Item]</span>
    <% else %>
      <i class="fa fa-lock"></i>
      <span title="You do not playback permission for the source item, <%=clip.master_file.media_object_id%>, this playlist item references.">[Inaccessible Item] <%=clip.master_file.media_object_id%></span>
    <% end %>
    <span class="pull-right"><%= clip.duration %></span>
  </li>
<% end %>

app/views/playlists/_share.html.erb
<%#
Copyright 2011-2020, The Trustees of Indiana University and Northwestern
  University.  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.

You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software distributed
  under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
  CONDITIONS OF ANY KIND, either express or implied. See the License for the
  specific language governing permissions and limitations under the License.
---  END LICENSE_HEADER BLOCK  ---
%>
<div id="share-button">
  <a data-toggle="collapse" href="#share-list" aria-expanded="false" aria-controls="collapseExample">
    <i class="fa fa-share-alt"></i>
    Share
  </a>
  <br class="clear"/>
</div>

<div id="share-list" class="collapse">
  <ul class="nav nav-tabs share-tabs">
    <%= render_conditional_partials :share, section:'share-tabs' %>
  </ul>

  <div class="tab-content">
    <%= render_conditional_partials :share, section:'tab-content' %>
  </div>
</div>
<% content_for :page_scripts do %>

<script>
  $(document).ready(function() {
    $('.share-tabs a').click(function (e) {
      e.preventDefault();
      $(this).tab('show');
    });
    $('.share-tabs li').first().toggleClass('active')
    $('.tab-content .tab-pane').first().toggleClass('active')
  })
</script>

<% end %>

app/views/playlists/import_variations_playlist.html.erb
<%#
Copyright 2011-2020, The Trustees of Indiana University and Northwestern
  University.  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.

You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software distributed
  under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
  CONDITIONS OF ANY KIND, either express or implied. See the License for the
  specific language governing permissions and limitations under the License.
---  END LICENSE_HEADER BLOCK  ---
%>
<div class="col-md-9 col-sm-8">
  <h1>Import Results</h1>
  <p>The following errors were encountered in the playlist file.</p>
  <div class="panel panel-default" style="background-color:#F9F9F9;">
    <div class="panel-body">
      <% playlist.items.each do |item| %>
        <% if item.clip.valid? && item.valid? %>
          <div><p style="font-weight: bold"><i class='fa fa-plus-circle success-color'></i> <%= item.title %></p></div>
        <% else %>
          <div>
            <p style="font-weight: bold"><i class='fa fa-times-circle danger-color'></i> <%= item.title %></p>
            <% if item.clip.errors.full_messages.include? "Master file field is required." %>
              <ul><li>No matching item found</li></ul>
            <% else %>
              <ul>
                <% item.errors.full_messages.select{|m|m!="Marker is invalid"}.each do |m| %>
                  <li><%= m %></li>
                <% end %>
                <% item.clip.errors.full_messages.each do |m| %>
                  <li><%= m %></li>
                <% end if !item.clip.valid?%>
                <% if item.errors.full_messages.include? "Marker is invalid" %>
                  <% item.marker.select{|m|!m.valid?}.each do |marker| %>
                    <li>Marker: <%= marker.title %>
                      <% if marker.errors.full_messages.include? "Master file field is required." %>
                        <ul><li>Master file field is required.</li></ul>
                      <% else %>
                        <ul>
                          <% marker.errors.full_messages.each do |m| %>
                            <li><%= m %></li>
                          <% end %>
                        </ul>
                      <% end %>
                    </li>
                  <% end %>
                <% end %>
              </ul>
            <% end %>
          </div>
        <% end %>
      <% end %>
    </div>
  </div>
  <br>
  <div class="col-lg-7">
    <p>This playlist is still able to be imported, but due to these errors will not contain the items above; other problems may be present as a result.</p>
    <p>For technical assistance regarding these errors please use our <strong><a href="/comments">contact form</a></strong>.</p>
    <br>
  </div>
  <div class = "col-lg-7">
    <a href="/playlists/" class="btn btn-danger outline_on">Cancel</a>
    <%= form_tag(import_variations_playlist_playlists_path, method:"post", style:"display:inline") do %>
      <input type="submit" class="btn btn-default outline_on" value="Import"/>
      <input type="hidden" name="skip_errors" value="true"/>
    <% end %>
  </div>
</div>